fig63 <- function(post=F)
{
if(post)
  {#ps.options (colors=ps.colors.rgb[c("blue", "magenta", "cyan",
   #"green", "MediumBlue", "red", "black", "yellow", "blue"),])
    postscript("Fig63.ps", width=4.4, height=3, horizontal=F, pointsize=8)
  }
 else {if(dev.cur()==1) motif(); par(ask=T)}

 par(mfrow = c(1, 1),mar=c(5,3,3,1)+0.1)
 par(mex=0.5,csi=0.11)

 SP500 <- matrix(scan("../datasets/SP500",skip=15),ncol=5,byrow=T)
 SP500 <- as.numeric(rev(SP500[,5]))            #closing prices
 SP500 <- SP500[6824:length(SP500)]             #snap shot
 tsplot(SP500,ylim=c(1200,1500), type="n")

############## Prepare the basics of the plot ###############
 h <- 20
 polygon(c(80-h, 80+h, 80+h, 80-h, 80-h), c(1400, 1400, 1275,1275,
 	1400), col=4)
 lines(c(80,80),c(1275, 1400), lty=2)

 polygon(c(200-h, 200+h, 200+h, 200-h, 200-h), c(1375, 1375, 1250, 1250,
 	1375), col=4)
 lines(c(200,200),c(1250, 1375), lty=2)
 title("Local linear fit for S&P500 index")
 lines(SP500)
 points(SP500)

 ############## local linear fit for 101 grid points
 x <- 1:length(SP500);
 grid <- seq(1,length(SP500),length=101)
 #fig63.res <- lls(x,SP500,20,grid)
 lines(fig63.res$grid,fig63.res$est,lwd=2) 
 ######### local least square at point t=80
   x <- 1:length(SP500);
   w <- 1 - (x-80)^2/h/h       ;                 #Epanechnikov kernel
   x <- x[ w > 0]
   y <- SP500[w > 0]
   w <- w[w > 0]
   coef <- lsfit(x,y,w)$coef
   lines(x,coef[1]+coef[2]*x,lty=1,lwd=2)
   lines(x,20*w+1275,lty=2,lwd=2)

 ######### local least square at point t=200
   x <- 1:length(SP500);
   w <- 1 - (x-200)^2/h/h       ;                 #Epanechnikov kernel
   x <- x[ w > 0]
   y <- SP500[w > 0]
   w <- w[w > 0]
   coef <- lsfit(x,y,w)$coef
   lines(x,coef[1]+coef[2]*x,lty=1,lwd=2)
   lines(x,20*w+1250,lty=2,lwd=2)
}
